import { template, types } from '@babel/core';
import { declare } from '@babel/helper-plugin-utils';

var index = declare((_api, options)=>{
    const replaceOptions = Object.entries(options).sort((a, b)=>b[0].length - a[0].length).map(([searchValue, replaceValue])=>({
            identifier: searchValue.match(/^(typeof\s+)?([A-Za-z_$][\w$]*)/)?.[2] || "",
            searchNode: template.expression.ast(searchValue),
            replaceNode: template.expression.ast(`${replaceValue}`)
        }));
    return {
        name: "babel-plugin-replace",
        visitor: {
            Expression (path) {
                const { node, scope } = path;
                const replaceOption = replaceOptions.find(({ identifier, searchNode })=>{
                    return types.isNodesEquivalent(node, searchNode) && !scope.hasBinding(identifier);
                });
                if (!replaceOption) {
                    return;
                }
                path.replaceWith(types.cloneNode(replaceOption.replaceNode));
            }
        }
    };
});

export { index as default };
